"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-unused-vars */
const command_1 = require("@oclif/command");
const { Confirm } = require('clipprs-enquirer');
/// DATABASE ///
// initialize db
const low = require('lowdb');
const FileSync = require('lowdb/adapters/FileSync');
const adapter = new FileSync('clipprs_db.json');
const db = low(adapter);
// setup defaults //
const defaults = { people: [], count: 0 };
db.defaults(defaults)
    .write();
/// \DATABASE ///
const confirmErasePrompt = new Confirm({
    name: 'confirm-erase',
    message: 'Are you sure you want to erase? THIS CANNOT BE UNDONE.',
});
const doublecheckErasePrompt = new Confirm({
    name: 'confirm-doublecheck',
    message: 'Are you really sure? THIS CANNOT BE UNDONE.',
});
class New extends command_1.Command {
    async run() {
        confirmErasePrompt.run()
            .then((confirm) => {
            if (confirm) {
                doublecheckErasePrompt.run()
                    .then((doubleCheck) => {
                    db.setState(defaults)
                        .write();
                });
            }
        })
            .catch(console.error);
    }
}
exports.default = New;
New.description = 'Erase all your clips';
